# konfigurationsDialog.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationsDialog(wx.Dialog):
    def __init__(
            self, parent,ID, title="Konfiguration der Objektdaten",
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        gbs = wx.GridBagSizer(vgap=5, hgap=5) # neu

        ### Label (StaticText) und TextCtrl
        ### Achtung: Erzeugen und Einbau in gbs hier getrennt !!!
        ## Datenbereich
        labelX = wx.StaticText(self, -1, "x-Position")
        self.textX = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelY = wx.StaticText(self, -1, "y-Position")
        self.textY = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelB = wx.StaticText(self, -1, "Breite")
        self.textBreite = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelT = wx.StaticText(self, -1, "Tiefe")
        self.textTiefe = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelW = wx.StaticText(self, -1, "Winkel")
        self.textWinkel = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelF = wx.StaticText(self, -1, "Farbe")
        self.textFarbe = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelFF = wx.StaticText(self, -1, "Füllfarbe")
        self.textFuellFarbe = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))

        gbs.Add(labelX, (0,0), flag=wx.ALL, border=10)
        gbs.Add(self.textX, (0,1), flag=wx.ALL, border=10)
        gbs.Add(labelY, (1,0), flag=wx.ALL, border=10)
        gbs.Add(self.textY, (1,1), flag=wx.ALL, border=10)
        gbs.Add(labelB, (2,0), flag=wx.ALL, border=10)
        gbs.Add(self.textBreite, (2,1), flag=wx.ALL, border=10)
        gbs.Add(labelT, (3,0), flag=wx.ALL, border=10)
        gbs.Add(self.textTiefe, (3,1), flag=wx.ALL, border=10)
        gbs.Add(labelW, (4,0), flag=wx.ALL, border=10)
        gbs.Add(self.textWinkel, (4,1), flag=wx.ALL, border=10)
        gbs.Add(labelF, (5,0), flag=wx.ALL, border=10)
        gbs.Add(self.textFarbe, (5,1), flag=wx.ALL, border=10)
        gbs.Add(labelFF, (6,0), flag=wx.ALL, border=10)
        gbs.Add(self.textFuellFarbe, (6,1), flag=wx.ALL, border=10)
        
        ## dem vertikalen Sizer hinzufuegen
        sizer.Add(gbs, 0, wx.GROW|wx.ALL, 5)
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, x, y, breite, tiefe, winkel, farbe, fuellfarbe):
        self.textX.ChangeValue(x)
        self.textY.ChangeValue(y)
        self.textBreite.ChangeValue(breite)
        self.textTiefe.ChangeValue(tiefe)
        self.textWinkel.ChangeValue(winkel)
        self.textFarbe.ChangeValue(farbe)
        self.textFuellFarbe.ChangeValue(fuellfarbe)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)
